(function($, window) {
	/*
	 * 图片预览:
	 * 1、mui-preview-header 头部
	 * 2、mui-slider-group 图片轮播缩放组
	 * 3、mui-preview-footer 底部
	 * 4、mui-preview-loading 加载大图提示
	 * 自定义:在头部class增加 mui-hidden,头部默认隐藏,当轮播组图片大于1张时显示
	 * */
	var template = '<div id="{{id}}" class="mui-slider mui-preview-image mui-fullscreen"><div class="mui-preview-header mui-hidden">{{header}}</div><div class="mui-slider-group"></div><div class="mui-preview-footer mui-hidden">{{footer}}</div><div class="mui-preview-loading"><span class="mui-spinner mui-spinner-white"></span></div></div>';
	var itemTemplate = '<div class="mui-slider-item mui-zoom-wrapper {{className}}"><div class="mui-zoom-scroller"><img src="{{src}}" data-preview-lazyload="{{lazyload}}" style="{{style}}" class="mui-zoom"></div></div>';
	var defaultGroupName = '__DEFAULT';
	var div = document.createElement('div');
	var imgId = 0;//无效变量
	var PreviewImage = function(options) {
		this.options = $.extend(true, {
			id: '__MUI_PREVIEWIMAGE',
			zoom: true,
			header: '<span class="mui-preview-indicator"></span>',
			footer: ''
		}, options || {});
		this.init();
		this.initEvent();
	};
	var proto = PreviewImage.prototype;
	proto.init = function() {
		var options = this.options;
		var el = document.getElementById(this.options.id);
		if (!el) {
			div.innerHTML = template.replace(/\{\{id\}\}/g, this.options.id).replace('{{header}}', options.header).replace('{{footer}}', options.footer);
			document.body.appendChild(div.firstElementChild);
			el = document.getElementById(this.options.id);
		}

		this.element = el;
		//存储用户滑动的图片组
		this.scroller = this.element.querySelector($.classSelector('.slider-group'));
		//指示信息;例如:2/5,当前是第2张图片，共5张图片
		this.indicator = this.element.querySelector($.classSelector('.preview-indicator'));
		/*
		 * 自定义-添加注释-加载提示,提示用户大图正在加载中
		 * */
		//this.loader = this.element.querySelector($.classSelector('.preview-loading'));
		/**END*/
		if (options.footer) {
			this.element.querySelector($.classSelector('.preview-footer')).classList.remove($.className('hidden'));
		}
		//搜集图片信息
		this.addImages();
	};
	proto.initEvent = function() {
		var self = this;
		/*
		 * 自定义-添加注释
		 * */
//		$(document.body).on('tap', 'img[data-preview-src]', function() {
//			self.open(this);
//			return false;
//		});
		/**END*/
		/*
		 * 自定义-修改-替换
		 * 自定义-修改-将所有laterClose和laterCloseEvent前都添加this或self
		 * 将代码
		self.laterClose = null;
		self.laterCloseEvent = function() {
			!self.laterClose && (self.laterClose = $.later(function() {
				self.loader.removeEventListener('tap', self.laterCloseEvent);
				self.scroller.removeEventListener('tap', self.laterCloseEvent);
				self.close();
			}, 300));
		};
		this.scroller.addEventListener('doubletap', function() {
			if (laterClose) {
				laterClose.cancel();
				laterClose = null;
			}
		});
		this.element.addEventListener('webkitAnimationEnd', function() {
			if (self.element.classList.contains($.className('preview-out'))) { //close
				self.element.style.display = 'none';
				self.element.classList.remove($.className('preview-out'));
				self.element.classList.remove($.className('preview-in'));
				self.laterClose = null;
			} else { //open
				self.loader.addEventListener('tap', self.laterCloseEvent);
				self.scroller.addEventListener('tap', self.laterCloseEvent);
			}
		});
		 * 替换为
		 * */
		self.laterClose = null;
		self.laterCloseEvent = function() {
			!self.laterClose && (self.laterClose = setTimeout(function() {
				self.laterClose = null;
				self.close();
			}, 300));
		};
		this.scroller.addEventListener('tap', function() {
			self.laterCloseEvent();
		});
		this.scroller.addEventListener('doubletap', function() {
			self.laterClose && clearTimeout(self.laterClose);
			self.laterClose = null;
		});
		this.element.addEventListener('webkitAnimationEnd', function() {
			if (self.element.classList.contains($.className('preview-out'))) { //close
				self.element.style.display = 'none';
				self.element.classList.remove($.className('preview-out'));
				self.element.classList.remove($.className('preview-in'));
				self.laterClose = null;
			}
		});
		/**END*/
		this.element.addEventListener('slide', function(e) {
			if (self.options.zoom) {
				var lastZoomerEl = self.element.querySelector('.mui-zoom-wrapper:nth-child(' + (self.lastIndex + 1) + ')');
				if (lastZoomerEl) {
					$(lastZoomerEl).zoom().setZoom(1);
				}
			}
			var slideNumber = e.detail.slideNumber;
			self.lastIndex = slideNumber;
			self.indicator && (self.indicator.innerText = (slideNumber + 1) + '/' + self.currentGroup.length);
			self._loadItem(slideNumber);
		});
	};
	proto.addImages = function(group, index) {
		this.groups = {};
		var imgs = [];
		if (group) {
			if (group === defaultGroupName) {
				/*
				 * 特别注意：如果希望将图片组归于该插件的默认组 defaultGroupName = '__DEFAULT',
				 * 则 img标签里不能有data-preview-group属性，即使设置为空值也不可以
				 * {img}没有设置{data-preview-group}，没有设置{data-preview-group}的{img}全部归于{defaultGroupName}组
				 */
				imgs = document.querySelectorAll("img[data-preview-src]:not([data-preview-group])");
			} else {
				//同组图片
				imgs = document.querySelectorAll("img[data-preview-src][data-preview-group='" + group + "']");
			}
		} else {
			//全部预览图片
			imgs = document.querySelectorAll("img[data-preview-src]");
		}
		if (imgs.length) {
			for (var i = 0, len = imgs.length; i < len; i++) {
				this.addImage(imgs[i]);
			}
		}
	};
	/*
	 * 初始化{this.groups},
	 * 初始化有关该图片的基本信息{src,lazyload,loaded,sWidth,sHeight,sTop,sLeft,sScale,el}
	 * 并全部保存至{this.groups}数组中
	 * */
	proto.addImage = function(img) {
		var group = img.getAttribute('data-preview-group');
		group = group || defaultGroupName;
		if (!this.groups[group]) {
			this.groups[group] = [];
		}
		var src = img.getAttribute('src');
		if (img.__mui_img_data && img.__mui_img_data.src === src) { //已缓存且图片未变化
			this.groups[group].push(img.__mui_img_data);
		} else {
			var lazyload = img.getAttribute('data-preview-src');
			if (!lazyload) {
				lazyload = src;
			}
			var imgObj = {
				src: src, //小图地址
				lazyload: src === lazyload ? '' : lazyload, //默认无大图时小图即为大图
				loaded: src === lazyload ? true : false, //该插件默认在打开预览模式前小图(img.src)已经加载完毕
				sWidth: 0, //{img.offsetWidth} 图片宽度,包含边框
				sHeight: 0, //{img.offsetHeight}
				sTop: 0, //{offset.top} 图片相对于窗口的偏移量，mui.js里的$.offset
				sLeft: 0, //{offset.left}
				sScale: 1,
				el: img //图片对象
			};
			this.groups[group].push(imgObj);
			img.__mui_img_data = imgObj;
		}
	};
	proto.empty = function() {
		this.scroller.innerHTML = '';
	};
	//刷新图片信息,由于对象的复制是引用，所以this.groups和this.currentGroup里的信息都会刷新
	proto._initImgData = function(itemData, imgEl) {
		if (!itemData.sWidth) {
			var img = itemData.el;
			itemData.sWidth = img.offsetWidth;
			itemData.sHeight = img.offsetHeight;
			var offset = $.offset(img);
			itemData.sTop = offset.top;
			itemData.sLeft = offset.left;
			itemData.sScale = Math.max(itemData.sWidth / window.innerWidth, itemData.sHeight / window.innerHeight);
		}
		imgEl.style.webkitTransform = 'translate3d(0,0,0) scale(' + itemData.sScale + ')';
	};
	/*
	 * 在 proto._initZoom() 里
		var maxZoom = self._getScale({
			width: zoomWrapperEl.offsetWidth,
			height: zoomWrapperEl.offsetHeight
		}, {
			width: zoomerWidth,
			height: zoomerHeight
		});
		maxZoom: Math.max(maxZoom, 1)
		
	 * {from.width}={zoomWrapperEl.offsetWidth} 图片标签img的宽度和高度
	 * {to.width}={zoomerWidth} 图片的实际宽度和高度
	 * 在理想状态下，图片标签的宽高比例应该与图片实际的宽高比例一致，这种情况下 scale===1
	 * 特别注意这里的scale不是由小图到大图的缩放比例，
	 * 仅是用于调节在用户点击图片后所呈现在用户眼前的大图的初始小图的宽高，然后用户在这张大图的初始小图上进行拖动缩放
	 * */
	proto._getScale = function(from, to) {
		var scaleX = from.width / to.width;
		var scaleY = from.height / to.height;
		var scale = 1;
		if (scaleX <= scaleY) {
			//from.height[2]/to.height[5] === scale * (from.width[1]/to.width[3])
			//scale === (2*3)/(1*5) > 1
			scale = from.height / (to.height * scaleX);
		} else {
			//from.width[3]/to.width[1] === scale * (from.height[5]/to.height[2])
			//scale === (3*2)/(5*1) > 1
			scale = from.width / (to.width * scaleY);
		}
		return scale;
	};
	proto._imgTransitionEnd = function(e) {
		var img = e.target;
		img.classList.remove($.className('transitioning'));
		img.removeEventListener('webkitTransitionEnd', this._imgTransitionEnd.bind(this));
	};
	//指定加载第{index+1}张图片
	proto._loadItem = function(index, isOpening) { //TODO 暂时仅支持img
		var itemEl = this.scroller.querySelector($.classSelector('.slider-item:nth-child(' + (index + 1) + ')'));
		var itemData = this.currentGroup[index];
		var imgEl = itemEl.querySelector('img');
		this._initImgData(itemData, imgEl);
		if (isOpening) {
			var posi = this._getPosition(itemData);
			imgEl.style.webkitTransitionDuration = '0ms';
			imgEl.style.webkitTransform = 'translate3d(' + posi.x + 'px,' + posi.y + 'px,0) scale(' + itemData.sScale + ')';
			imgEl.offsetHeight;
		}
		//如果该图片还未加载完毕并且有{data-preview-lazyload}大图地址
		if (!itemData.loaded && imgEl.getAttribute('data-preview-lazyload')) {
			var self = this;
			/*
			 * 自定义-添加注释
			 * */
			//self.loader.classList.add($.className('active'));
			/**END*/
			//移动位置动画
			imgEl.style.webkitTransitionDuration = '0.5s';
			/* http://biancheng.dnbcw.info/javascript/463870.html
			 * bind:将_imgTransitionEnd里的指针指向self并返回函数本身，也不会执行。类似于call，但call会执行函数并返回retrun的值
			 * bind:这里将bind后返回的函数作为回调函数，回调函数里的指针指向self
			*/
			imgEl.addEventListener('webkitTransitionEnd', self._imgTransitionEnd.bind(self));
			imgEl.style.webkitTransform = 'translate3d(0,0,0) scale(' + itemData.sScale + ')';
			/*
			 * 自定义:在this.loadImage添加参数 itemData
			 * */
			this.loadImage(imgEl, function() {
				itemData.loaded = true;
				imgEl.src = itemData.lazyload;
				self._initZoom(itemEl, this.width, this.height);
				imgEl.classList.add($.className('transitioning'));
				imgEl.addEventListener('webkitTransitionEnd', self._imgTransitionEnd.bind(self));
				imgEl.setAttribute('style', '');
				imgEl.offsetHeight;
				/*
				 * 自定义-添加注释
				 * */
				//self.loader.classList.remove($.className('active'));
				/**END*/
			});
		} else {
			//大图已加载完毕 或 img标签没有指定大图，就用小图
			itemData.lazyload && (imgEl.src = itemData.lazyload);
			this._initZoom(itemEl, imgEl.width, imgEl.height);
			imgEl.classList.add($.className('transitioning'));
			imgEl.addEventListener('webkitTransitionEnd', this._imgTransitionEnd.bind(this));
			imgEl.setAttribute('style', '');
			imgEl.offsetHeight;
		}
		//设置上一张和下一张图片的offsetWidth,offsetHeight,sTop,sLeft,sScale,style.webkitTransform
		this._preloadItem(index + 1);
		this._preloadItem(index - 1);
	};
	proto._preloadItem = function(index) {
		var itemEl = this.scroller.querySelector($.classSelector('.slider-item:nth-child(' + (index + 1) + ')'));
		if (itemEl) {
			var itemData = this.currentGroup[index];
			if (!itemData.sWidth) {
				var imgEl = itemEl.querySelector('img');
				this._initImgData(itemData, imgEl);
			}
		}
	};
	/*
	 * zoomWrapperEl缩放容器，即img的父标签
	 * zoomerWidth,zoomerHeight:大图的实际宽度和高度;
	 * 设置maxZoom，开始缩放
	 * */
	proto._initZoom = function(zoomWrapperEl, zoomerWidth, zoomerHeight) {
		if (!this.options.zoom) {
			return;
		}
		//该图已经做好了缩放准备
		if (zoomWrapperEl.getAttribute('data-zoomer')) {
			return;
		}
		var zoomEl = zoomWrapperEl.querySelector($.classSelector('.zoom'));
		if (zoomEl.tagName === 'IMG') {
			var self = this;
			var maxZoom = self._getScale({
				//缩放容器的宽度和高度
				width: zoomWrapperEl.offsetWidth,
				height: zoomWrapperEl.offsetHeight
			}, {
				//图片的实际宽度和高度
				width: zoomerWidth,
				height: zoomerHeight
			});
			$(zoomWrapperEl).zoom({
				maxZoom: Math.max(maxZoom, 1)
			});
		} else {
			$(zoomWrapperEl).zoom();
		}
	};
	proto.loadImage = function(imgEl, callback) {
		var onReady = function() {
			callback && callback.call(this);
		};
		var img = new Image();
		img.onload = onReady;
		img.onerror = onReady;
		img.src = imgEl.getAttribute('data-preview-lazyload');
	};
	proto.getRangeByIndex = function(index, length) {
		return {
			from: 0,
			to: length - 1
		};
		//		var from = Math.max(index - 1, 0);
		//		var to = Math.min(index + 1, length);
		//		if (index === length - 1) {
		//			from = Math.max(length - 3, 0);
		//			to = length - 1;
		//		}
		//		if (index === 0) {
		//			from = 0;
		//			to = Math.min(2, length - 1);
		//		}
		//		return {
		//			from: from,
		//			to: to
		//		};
	};
	/*
	 * 获取图片的位置信息
	 * itemData：存储了图片位置信息
	 * */
	proto._getPosition = function(itemData) {
		var sLeft = itemData.sLeft - window.pageXOffset;
		var sTop = itemData.sTop - window.pageYOffset;
		var left = (window.innerWidth - itemData.sWidth) / 2;
		var top = (window.innerHeight - itemData.sHeight) / 2;
		return {
			left: sLeft,
			top: sTop,
			x: sLeft - left,
			y: sTop - top
		};
	};
	//刷新zoom，将{groupArray===this.groups[group]}作为当前缩放组，将该组第{index}张图片作为当前缩放图片
	proto.refresh = function(index, groupArray) {
		this.currentGroup = groupArray;
		//重新生成slider
		var length = groupArray.length;
		var itemHtml = [];
		//currentRange:this.getRangeByIndex() 直接返回 return {from: 0,to: length - 1};
		var currentRange = this.getRangeByIndex(index, length);
		var from = currentRange.from; //0
		var to = currentRange.to + 1; //length
		var currentIndex = index;
		var className = '';
		var itemStr = '';
		var wWidth = window.innerWidth;
		var wHeight = window.innerHeight;
		for (var i = 0; from < to; from++, i++) {
			var itemData = groupArray[from];
			var style = '';
			if (itemData.sWidth) {
				style = '-webkit-transform:translate3d(0,0,0) scale(' + itemData.sScale + ');transform:translate3d(0,0,0) scale(' + itemData.sScale + ')';
			}
			//初始时轮播图片组设置src和data-preview-lazyload即原页面img标签中的src和data-preview-src
			itemStr = itemTemplate.replace('{{src}}', itemData.src).replace('{{lazyload}}', itemData.lazyload).replace('{{style}}', style);
			if (from === index) {
				currentIndex = i;
				className = $.className('active');
			} else {
				className = '';
			}
			itemHtml.push(itemStr.replace('{{className}}', className));
		}
		this.scroller.innerHTML = itemHtml.join('');
		this.element.style.display = 'block';
		this.element.classList.add($.className('preview-in'));
		this.lastIndex = currentIndex;
		this.element.offsetHeight;
		//滑动至指定图片
		$(this.element).slider().gotoItem(currentIndex, 0);
		this.indicator && (this.indicator.innerText = (currentIndex + 1) + '/' + this.currentGroup.length);
		//加载指定图片
		this._loadItem(currentIndex, true);
	};
	proto.openByGroup = function(index, group) {
		index = Math.min(Math.max(0, index), this.groups[group].length - 1);
		this.refresh(index, this.groups[group]);
	};
	proto.open = function(index, group) {
		//如果已经进入预览模式
		if (this.isShown()) {
			return;
		}
		//打开{this.groups[group][index}]图片,缩放该图片
		if (typeof index === "number") {
			group = group || defaultGroupName;
			this.addImages(group, index); //刷新当前group
			this.openByGroup(index, group); //刷新当前zoom
		} else {
			group = index.getAttribute('data-preview-group');
			group = group || defaultGroupName;
			this.addImages(group, index); //刷新当前group
			/*
			 * 在初始化时{proto.init()}=>{proto.addImage()}=>{proto.addImage()},将图片初始化信息存储至{this.groups}数组中
			 * {this.groups[group]} 存储每组图片的信息
			 * {index.__mui_img_data} 存储了该图片信息
			 * {Array.indexOf(value,index)}为mui的扩展;与{String.indexOf(value,index)}用法一致;
			 */
			this.openByGroup(this.groups[group].indexOf(index.__mui_img_data), group);
		}
	};
	proto.close = function(index, group) {
		if (!this.isShown()) {
			return;
		}
		this.element.classList.remove($.className('preview-in'));
		this.element.classList.add($.className('preview-out'));
		
		/**
		 * 自定义-注释-注释掉关闭图片前的缩放动画
		 */
//		var itemEl = this.scroller.querySelector($.classSelector('.slider-item:nth-child(' + (this.lastIndex + 1) + ')'));
//		var imgEl = itemEl.querySelector('img');
//		if (imgEl) {
//			imgEl.classList.add($.className('transitioning'));
//			var itemData = this.currentGroup[this.lastIndex];
//			var posi = this._getPosition(itemData);
//			var sLeft = posi.left;
//			var sTop = posi.top;
//			if (sTop > window.innerHeight || sLeft > window.innerWidth || sTop < 0 || sLeft < 0) { //out viewport
//				imgEl.style.opacity = 0;
//				imgEl.style.webkitTransitionDuration = '0.5s';
//				imgEl.style.webkitTransform = 'scale(' + itemData.sScale + ')';
//			} else {
//				if (this.options.zoom) {
//					$(imgEl.parentNode.parentNode).zoom().toggleZoom(0);
//				}
//				imgEl.style.webkitTransitionDuration = '0.5s';
//				imgEl.style.webkitTransform = 'translate3d(' + posi.x + 'px,' + posi.y + 'px,0) scale(' + itemData.sScale + ')';
//			}
//		}
		/**END*/
		
		/**
		 * 自定义-添加
		 */
		this.laterClose && clearTimeout(this.laterClose);
		this.laterClose = null;
		plus.webview.getWebviewById(pub.winIdA).isVisible() && winBack();
		/**END*/
		
		var zoomers = this.element.querySelectorAll($.classSelector('.zoom-wrapper'));
		for (var i = 0, len = zoomers.length; i < len; i++) {
			$(zoomers[i]).zoom().destroy();
		}
		$(this.element).slider().destroy();
		
		/**
		 * 自定义-去除注释
		 */
		this.empty();
		/**END*/
	};
	proto.isShown = function() {
		return this.element.classList.contains($.className('preview-in'));
	};
	var previewImageApi = null;
	$.previewImage = function(options) {
		if (!previewImageApi) {
			previewImageApi = new PreviewImage(options);
		}
		return previewImageApi;
	};
	$.getPreviewImage = function() {
		return previewImageApi;
	}
})(mui, window);